package com.maroontress.sanctuary.xclass;

import com.maroontress.sanctuary.Tex;
import com.maroontress.sanctuary.CommentedString;
import com.maroontress.sanctuary.ChildrenFilter;
import com.maroontress.sanctuary.Description;
import com.maroontress.sanctuary.Group;
import com.maroontress.sanctuary.IDManager;
import java.io.PrintWriter;
import org.w3c.dom.Element;

/**
   եɤǤ

   fieldǤбޤ
*/
public class XField {

    /** 롼 */
    private Group group;

    /** type° */
    private String type;

    /** name° */
    private String name;

    /** descǤ */
    private Description desc;

    /**
       եɤޤ

       @param g 롼
       @param elem field
    */
    public XField(final Group g, final Element elem) {
	group = g;
	name = IDManager.getInstance().getIDAttribute(elem, "name");
	type = g.expandAT(elem, "type");
	g.importTags(type);

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(g, c.getDirectChildrenByTagName("desc"));
    }

    /**
       ե̾ޤ

       @return ե̾
    */
    public String getName() {
	return name;
    }

    /**
       եɤηɽʸޤ

       @return եɤηɽʸ
    */
    private String getTypeText() {
	int k = CommentedString.indexOf(type, '#');
	if (k != -1) {
	    return type.substring(0, k) + type.substring(k + 1);
	} else {
	    return type;
	}
    }

    /**
       ƬꤷƥɤϤޤ

       @param wr 饤
       @param prefix Ƭ
    */
    private void printCode(final PrintWriter wr, final String prefix) {
	int k = CommentedString.indexOf(type, '#');
	if (k != -1) {
	    wr.println(prefix
		       + type.substring(0, k)
		       + name
		       + type.substring(k + 1)
		       + ";");
	} else {
	    wr.println(prefix + type + " " + name + ";");
	}
    }

    /**
       ɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	printCode(wr, "    ");
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	String prefix = "struct " + group.getPackageName() + "_impl_"
	    + group.getName() + ".";

	wr.println(""
+ "<tr>\n"
+ "  <td align=\"right\" valign=\"top\" width=\"1%\">\n"
+ "    <font size=\"-1\">&nbsp;" + group.getHTML(getTypeText())
+ "</font>\n"
+ "  </td>\n"
+ "  <td valign=\"top\">"
+ "<a href=\"#" + prefix + name + "\">"
+ "<b>" + name + "</b></a>" + "<br>"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "</tr>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	String prefix = "struct " + group.getPackageName() + "_impl_"
	    + group.getName() + ".";
	String leftType, rightType;

	int k = CommentedString.indexOf(type, '#');
	if (k == -1) {
	    leftType = type;
	    rightType = "";
	} else {
	    leftType = type.substring(0, k);
	    rightType = type.substring(k + 1);
	}

	wr.print(""
+ "<p><a name=\"" + prefix + name + "\"></a>"
+ "<font size=\"+1\"><b>" + name + "</b></font></p>\n"
+ "<table cellpadding=\"0\" cellspacing=\"0\">\n"
+ "  <tr>\n"
+ "    <td nowrap>" + group.getHTML(leftType)
		    + " <b>" + name + "</b>"
		    + group.getHTML(rightType)
		    + "</td>\n"
+ "  </tr>\n"
+ "</table>\n"
+ "<dl>\n"
+ "<dd>" + desc.getText() + "</dd>\n");

	wr.println(""
+ "</dl>");
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	String ns = group.getPackageName() + "." + group.getName();
	String prefix = "struct " + group.getPackageName() + "_impl_"
	    + group.getName() + ".";
	String texLabel = Tex.safeTarget(ns + "." + prefix + name);
	String texName = Tex.safe(name);
	String leftType, rightType;

	int k = CommentedString.indexOf(type, '#');
	if (k == -1) {
	    leftType = type;
	    rightType = "";
	} else {
	    leftType = type.substring(0, k);
	    rightType = type.substring(k + 1);
	}
	leftType = group.getTEX(leftType);
	rightType = group.getTEX(rightType);

	// Syntax
	wr.println("");
	wr.println("\\Sid{" + texName + "}");
	wr.println("\\Slabel{:" + texLabel + ":}");
	wr.println("\\nopagebreak");
	wr.println("\\begin{Ssyntax}%");
	wr.println(leftType + " {\\bfseries " + texName + "}" + rightType);
	wr.println("\\end{Ssyntax}");

	// Description
	wr.println("");
	wr.print(desc.getTexText());
    }
}
